Package: agilp
Type: Package
Title: Agilent expression array processing package
Version: 3.44.0
Date: 2012-06-10
Author: Benny Chain <b.chain@ucl.ac.uk>
Maintainer: Benny Chain <b.chain@ucl.ac.uk>
Depends: R (>= 2.14.0)
Description: More about what it does (maybe more than one line)
License: GPL-3
Packaged: 2026-04-28 20:32:16 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/agilp
git_branch: RELEASE_3_23
git_last_commit: 3c7a692
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no

Loader <-function(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output",""),t=file.path(system.file(package="agilp"),"input1","template.txt"),f="TRUE",r=2,A=2,B=5){

d<-input
template<-read.table(file = t, header = FALSE, quote = "", sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)

#select some arrays; define range of arrays within template you want to read 
#in. A is number of first array, B is last array  

arrays<-template[c(A:B),c(1:5)]
n<-dim(arrays)[1]

i<-1
j<-1
for (i in 1:n){
 
name<-paste(input,arrays[j,r], sep="")

if(file.exists(name)){
data<-read.table(file = name, row.names=1, header = TRUE, sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)

error2<-paste("Arrays number",arrays[j,r], "contains non numerical data")
if (is.numeric(data[,1])==FALSE) message(error2)

#correct for new negative
rownames(data)[which(rownames(data)=="(-)3xSLv1")]<-"3xSLv1"

if (f!="TRUE"){
if (i>1){data<-merge(data1,data,by.x="row.names",by.y="row.names")}
if(i>1){rownames(data)<-data[,1]}
data1<-data
if(i>1){data1<-data1[,-1]}
}
if (f=="TRUE"){
colnames(data)<-arrays[j,r]
outputf<-paste(output,arrays[j,r],sep = "")
write.table(data,outputf,sep="\t", col.names = NA, row.names = rownames(data))
}
#end of read loops

} else {message("Array number ",arrays[j,r], " does not exist")
arrays<-arrays[(-j),]
j<-j-1}		
#end of i loop 
j<-j+1
	}

if (f!="TRUE"){
colnames(data1)<-arrays[,r]
dataout<- NULL; rm(dataout); # Dummy to trick R CMD check
dataout<<-data1

out<-paste(output,"all_data.txt",sep="")
write.table(dataout,file=out,col.names=NA,sep="\t")
return(dataout<<-data1)
}
#END
}

AALoess <-
function(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output",""), baseline=file.path(system.file(package="agilp"),"input1","testbase.txt"),LOG="TRUE"){
#input baseline

c3<-read.table(file = baseline, row.names=1, header=TRUE, sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)
#c2<-as.numeric(c3[,1])

arrays<-dir(input)
n<-length(arrays)
##############################################################################
#set up array with which to collect the sum of squared errors between 
#baseline mean and predicted 
SSE1<- arrays
dim(SSE1)<-c(n,1)
zeros<-rep(0,n)
dim(zeros)<-c(n,1)
SSE<-cbind(SSE1,zeros)

#############################################################################
#
#read in raw datafiles

i<-1
for (i in 1:n){
#load in raw unnormalised data
name<-file.path(input,arrays[i], fsep = .Platform$file.sep)

if(file.exists(name)){
data2<-read.table(file = name,header=TRUE,row.names=1,sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)
data3<-merge(c3,data2,by.x="row.names",by.y="row.names")
c1<-as.numeric(data3[,3])
c2<-as.numeric(data3[,2])

###############################################################################

if (is.numeric(c1)==FALSE) message("non-numeric data")
if (LOG=="TRUE"){c1<-log(c1,2)}
loessdata<-loess(c1 ~ c2, span = 0.1)

#calculate the new normalised data; z is difference between predicted and actual

zg<-c2-predict(loessdata,c2)
zgsq<-zg*zg
SSE[i,2]<-sum(zgsq)
norm<-data.frame(c1+zg)
rownames(norm)<-data3[,1]

##############################################################################
#Output
#write file with normalised data

array_name<-if(grepl("Raw",arrays[i],ignore.case=TRUE)){sub("Raw","",arrays[i],ignore.case=TRUE)}else {
array_name<-arrays[i]}
dg<-paste(output,"n",array_name,sep = "")
colnames(norm)<-paste("n",array_name,sep="")
write.table(norm,dg,sep="\t",col.names=NA,row.names=TRUE)
}else message("Array ",arrays[i], "is not present")

#end of for loop for each file
}
#write file with squared sum errors
colnames(SSE)<-c("array","SSE")
dg1<-paste(output,"SSE_",Sys.Date(),".txt",sep = "")
write.table(SSE,dg1,sep="\t",col.names=TRUE,row.names=FALSE)
hist(as.numeric(SSE[,2]))

#end of function

}

Equaliser <-
function(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output","")){
arrays<-dir(input)
n<-length(arrays)

i<-1
name<-paste(input,arrays[i], sep="")
error<-paste("First file is absent so this data is not reliable")
if(file.exists(name)){
data<-read.table(file = name, row.names=1, header=TRUE, sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)
}else message("First file is absent so this data is not reliable")


#########################################################################################################
#first pass runs though all files and finds common demoninator in file data
for (i in 2:n) {
name<-paste(input,arrays[i], sep="")
error<-paste("Arrays number",arrays[i], "is not present")
if(file.exists(name)){
data1<-read.table(file = name, row.names=1, header=TRUE, sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)
common <- merge(data,data1,by.x="row.names",by.y="row.names")
data <-common[,-3]
data<-data.frame(data[,-1])
rownames(data)<-common[,1]
}else message("Array number ",arrays[i], " is not present")
}

#########################################################################################################
#second pass runs though all files again and merges with common demoninator and then saves with same name
for (i in 1:n) {

name<-paste(input,arrays[i], sep="")
if(file.exists(name)){
data1<-read.table(file = name, row.names=1, header=TRUE, sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)
common <- merge(data,data1,by.x="row.names",by.y="row.names")

outfile<-data.frame(common[,3])
rownames(outfile)<-common[,1]
colnames(outfile)<-colnames(data1)

#Output
array_name<-arrays[i]
dg<-paste(output,"s_",array_name,sep = "")
write.table(outfile,dg,sep="\t",col.names=NA,row.names=TRUE)
} else message("Arrays number",arrays[i], "is not present")
#end of for loop inputing files
}
#end of function
}

AAProcess<-function(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output/",""),s=9){

#reads the input directory of file names into directory
directory<-unlist(dir(input))[]
M<-length(directory)

#read in first data set skipping first "s" rows

inputpath<-c(rep(1,M))
i<-1

for (i in 1:M)
{
inputpath[i]<-file.path(input,directory[i],fsep = .Platform$file.sep)

if(file.exists(inputpath[i])){
data<-read.table(inputpath[i],skip = s, header = FALSE, quote = "",comment.char = "", sep = "\t", fill = TRUE,  stringsAsFactors=FALSE )
colnames(data) <- data[1,]
data<-data[-1,]
probenames <- data[,"ProbeName"]
probes<-levels(factor(probenames))

green<-tapply(as.numeric(data[,"gMedianSignal"]),probenames,mean)
rownames(green)<-probes
Rawdg<-paste(output,"gRaw_",directory[i],sep = "")
greencol<-paste("gRaw_",directory[i],sep = "")
write.table(green,Rawdg,sep="\t", col.names = greencol, row.names = probes)

###############################################################################
if (match(as.vector("rMedianSignal"),as.vector(colnames(data)),nomatch=0)>0) {
red<-tapply(as.numeric(data[,"rMedianSignal"]),probenames,mean)
rownames(red)<-probes
Rawdr<-paste(output,"rRaw_",directory[i],sep = "")
redcol<-paste("rRaw_",directory[i],sep = "")
write.table(red,Rawdr,sep="\t", col.names = redcol, row.names = probes)
}
}else message("Array ",inputpath[i], "is not present")
#end of for loop
}
}

IDswop <-
function(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output",""),fun="mean",annotation=file.path(system.file(package="agilp"),"input1","annotation.txt"), source_ID = "ProbeID", target_ID="EnsemblID", ERR=0.2){

#set of files to be processed
datafiles<-dir(input)

#input annotation file
annotation1<-read.table(annotation,header = TRUE, fill=TRUE,quote="", sep = "\t",   stringsAsFactors=FALSE )

#input data files
i<-1

if (ERR>=0 & ERR<=1){
for (i in 1:length(datafiles)){
name<-paste(input,datafiles[i],sep="")
error<-paste("Arrays number",datafiles[i], "is not present")
if(file.exists(name)){
datar<-read.table(name,header=TRUE,row.names=1,fill=TRUE,sep = "\t",  stringsAsFactors=FALSE)

#merge data with its own annotation
IDs<-merge(annotation1,datar,by.x=source_ID,by.y="row.names")

col1<-levels(as.factor(IDs[,target_ID]))
if(fun=="mean"){col2<-as.vector(tapply(IDs[,dim(IDs)[2]],factor(IDs[,target_ID]),mean))}
if(fun=="max") {col2<-as.vector(tapply(IDs[,dim(IDs)[2]],factor(IDs[,target_ID]),max))}

col3<-as.vector(tapply(IDs[,dim(IDs)[2]],factor(IDs[,target_ID]),sd))
#col4<-tabulate(factor(IDs[,target_ID]))
col4<-col3/col2
newID<-data.frame(col1,col2,col3,col4)

#filter out all rows where the duplicates differ by more than ERR
newID1<-newID[(is.na(newID[,4])==T | newID[,4]<ERR),]

#remove any rows that have no identifier 
newID2<-newID1[newID1[,1]!="",]
newID3<-data.frame(newID2[,2])

name1<-paste(output,sub(".txt","",datafiles[i],),"_",target_ID,".txt",sep="")
name2<-paste(sub(".txt","",datafiles[i],),"_",target_ID,".txt",sep="")
colnames(newID3)<-name2
rownames(newID3)<-newID2[,1]
write.table(newID3,name1,sep="\t",col.names=NA)
}else message(error)

#end of for loop


}
#end of error between 0 and 1 check 
}else {message("ERR Must lie between 0 and 1")}
#end of function
}

Baseline <-
function(NORM="LOG",allfiles="TRUE",r=2,A=2,B=3,input=file.path(system.file(package="agilp"),"input",""),baseout=file.path(system.file(package="agilp"),"output","baseline.txt"),t=file.path(system.file(package="agilp"),"input1","template.txt")){

if (allfiles != "TRUE"){template<-read.table(file = t, quote = "",comment.char = "", sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)
arrays<-template[c(A:B),r]}

if(allfiles=="TRUE"){arrays<-dir(input)}
n<-length(arrays)

#load first array 
d<-input 
name<-paste(d,arrays[1], sep="")

if(file.exists(name)){
data1<-read.table(file = name,row.names=1,header=TRUE,comment.char = "", sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)

if (is.numeric(data1[,1])==FALSE) message("non-numeric data")

m<-dim(data1)[1]


# load arrays
if (NORM=="LOG") {data<-data1
data[,1]<-log2(data[,1])} else data<-data1
i<-2

for (i in 2:n){ 
name<-paste(d,arrays[i], sep="")
error<-paste("Arrays number",arrays[i], "is not present")
if(file.exists(name)){
datai<-read.table(file = name,row.names=1,header=TRUE, comment.char = "", sep = "\t", fill = TRUE,  stringsAsFactors=FALSE)
if (is.numeric(datai[,1])==FALSE) print (error)
data<-merge(data,datai,by.x="row.names",by.y="row.names")
if (NORM=="LOG") { data[,3]<-log2(data[,3])}

data[,2]<-data[,2]+data[,3]
editprobes<-data[,1]
data<-data[,-1]
data<-as.data.frame(data[,-2])
row.names(data)<-editprobes
}
else message("Array number ",arrays[i], " is not present")
}
mean<-data
mean[,1]<-data[,1]/i


write.table(mean,baseout,col.names=NA,sep="\t")

}
else message("the first file is missing so the programme stops")


}

filenamex <-function(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output","")){
names<-data.frame(dir(input))
namesout<-paste(output,"names.txt",sep="")
write.table(names,namesout,sep="\t",col.names=NA,row.names=TRUE)
###THE END
}

\documentclass{article}
% Define margins around page using geometry package
\usepackage[margin=0.5in]{geometry}

\usepackage{amscd}
\usepackage{ifthen}
\usepackage[utf8]{inputenc}
\usepackage{Sweave}

\title{Agilp Manual Vignette}
% Omit date from title with empty parentheses
\date{}
\author{Benny Chain}
% \VignetteIndexEntry{An R Package for processing expression microarray data}
% \VignetteKeyword{utilities}
% \VignetteKeyword{package}

%\usepackage{Sweave}
\begin{document}
\SweaveOpts{concordance=TRUE}
\maketitle
% Remove commas to get current date 
%\date{}
%title{}
%\author{Benny Chain}
%\date{}
<<echo=FALSE>>=
options(width=60)
@
\SweaveOpts{keep.source=TRUE}

\section*{Introduction}
This package was developed to provide a pipeline for the low-level analysis of gene expression microarray data, primarily focused on the Agilent platform, but which also provides utilities which may be useful for other platforms. Agilp v2.0 is made up of five processing functions, which are described briefly below and in more detail in the individual help files for each function. The package is designed for people with little previous experience of R, or of microarray analysis. The package was developed for use in the Innate2Adaptive Immunity Laboratory, Division of Infection and Immunity, UCL, London run by Benny Chain and Maddy Noursadeghi. A number of references describing the microarray work from the laboratory are given at the end of this document. 

\section*{A note on default paths in agilp functions}The default folders for all the functions in agilp use folders input, input1 and output within the agilp folder. The user files to be processed (e.g. array scanner files or the output of agilp functions themselves) should be placed within the input or input1 folders as instructed in the help files. Note that after installing the package these folders will initially contain a dummy file called toberemoved.txt in order to avoid the installation process removing empty folders.These dummy files should be deleted before use. To locate the path of the agilp folder on your computer type 
<<>>=
file.path(system.file(package="agilp"))
@
Alternatively, the user can create their own input and output directories, and alter the path description in the function call as appropriate.
 
\section*{Workflow}

A typical workflow for using the package is described below. The examples are designed to be implemented sequentially. \begin{itemize} \item \textbf{AAProcess. Extract and save the red and green median expression data from Agilent scanner arrays, averaging replicate probes}. The raw (unprocessed) expression data is first extracted from the scanner files which are in tab delimited .txt format. This step is platform specific, and uses the column \textit{gMedianSignal} or \textit{rMedianSignal} to identify the data to use. The expression values for replicate probes are averaged. The function can use single or two colour outputs, and treats each colour independently. Output is one spreadsheet per microarray per colour, saved as tab delimited text files  to a directory of choice. Each file contains all probe names (first column) and raw (untransformed, unnormalized) expression levels (second column). 

Examples. This example extracts expression data from two sample array scanner files which are found in the folder "scanner" within the agilp package extdata folder and places them in the folder output within the agilp package folder.
<<>>=
library(agilp)
inputdir<-file.path(system.file(package="agilp"),"extdata","scanner/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
AAProcess(input = inputdir, output = outputdir, s = 9)
@

To remove these files again and empty the output directory use :\newline
<<>>=
unlink(file.path(system.file(package="agilp"),"output","","*.*", 
fsep = .Platform$file.sep), recursive=FALSE)
@
The number of lines header to be skipped from scanner array files can be changed from the default value of 9 by setting variable s.
AAProcess(input = inputdir, output = outputdir, s = 10)


\item \textbf{filenamex. Copy extracted raw file names to template}. Typically, the array file names are stored in a database We use a simple spreadsheet for this (e.g. Excel or other) which contains details such as the date the experiments were run, the types of samples, the experimenter , and any other important experimental detail (see \textit{sample\_template.txt} in the agilp extdata folder for an example). However, a major source of documentation error occurs while entering the array files names into the template file (array file names are often very long arbitrary alphanumeric sequences). For this reason we use \textit{filenamex} which outputs a text file containing the names of all the files in a directory; this list can be easily copied and pasted directly into a template file. 

Examples.This example makes a list of the names of all the files in the folder agilp/extdata/raw and saves it in a file called names.txt (tab delimited) in the folder agilp/output.
<<>>=
library(agilp) 
inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
filenamex(input=inputdir,output=outputdir)
@
To remove these files again and empty the output directory use :\newline
<<>>=
unlink(file.path(system.file(package="agilp"),"output","","*.*", 
fsep = .Platform$file.sep), recursive=FALSE)
@
\item \textbf{Baseline. Generate a normalisation baseline file.} \newline The \textit{AALoess} normalisation function (see below) requires a `baseline' file which contains the mean value for each probe from a number of different arrays against which to normalise each new array. \textit{Baseline} generates such a baseline from a set of arrays. The set can be either all arrays in a chosen directory, or selected from a template file (see help file for more details). By default, all array data is base 2 log transformed before calculating the mean. If the files to be analysed contain different numbers of identifiers, the output will contain only the data for the IDs common to the whole set.

Examples. Takes all the files of unprocessed data in folder agilp/extdata/raw) , calculates the mean expression value for each probe, and saves as agilp/output/testbase.txt.
<<>>=
library(agilp)
inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputbase<-file.path(system.file(package="agilp"),"output", "testbase.txt", fsep = .Platform$file.sep)
template<-file.path(system.file(package="agilp"),"extdata","sample_template.txt", fsep = .Platform$file.sep)
Baseline(NORM="LOG",allfiles="TRUE",r=2,A=2,B=3,input=inputdir, baseout=outputbase, t = template)
@

Alternatively the following example uses only those data files defined in column 2, rows 2-5 of the template file. In additon, this example does not log transform the data.
<<>>=
Baseline(NORM="FALSE",allfiles="FALSE",r=2,A=2,B=5,input=inputdir, baseout=outputbase, t = template)
@

To remove these files again and empty the output directory use :\newline
<<>>=
unlink(file.path(system.file(package="agilp"),"output","","*.*", 
fsep = .Platform$file.sep), recursive=FALSE)
@
\item \textbf{Loader. Select set of processed array files from directory according to criteria from a template file}. It is often necessary to select a series of expression array data files (for example generated by \textit{AAProcess}) from a directory containing many such files (our repository has around 1000 array data sets so far) according to some criteria in the template file. For example, one might want to analyze all samples from particular dates, or tissue type etc.  \textit{Loader} inputs a template file  in which each row contains the details for a separate array, and which has previously been sorted according to some predefined criteria (see \textit{sample\_template.txt} in the agilp/extdata for an example). It uses the array file names for a set of rows of the template (first and last row chosen by user, but must be contiguous), and either (if f =``TRUE'') transfers the chosen files to a different directory, or outputs a single file (by default saved as alldata.txt) in which each column contains one array set of data.  

Examples. This will copy the files with names given in column 2 , rows 2:3 of the sample template file from the input folder to output folder. 
<<>>=
inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
template<-file.path(system.file(package="agilp"),"extdata","sample_template.txt",
fsep = .Platform$file.sep)

Loader(input=inputdir,output=outputdir,t=template,f="TRUE",r=2,A=2,B=5)
@

Alternatively this will output a single file all\_data.txt with the same data in a merged file. The file is also output back to R as object dataout
<<>>=
Loader(input=inputdir,output=outputdir,t=template,f="FALSE",r=2,A=2,B=5)
dim(dataout)
@
To remove these files again and empty the output directory use :\newline
<<>>=
unlink(file.path(system.file(package="agilp"),"output","","*.*", 
fsep = .Platform$file.sep), recursive=FALSE)
@
For further detail on function variables see individual help files.


\item \textbf{AALoess. Normalises a set of gene expression data files using LOESS against a reference data set.} 
An important aspect of analysing sets of microarray expression data is to be able to compare different experiments carried out at different times. This requires being able to normalize 	data sets as far as possible correcting for global differences between experiments. \textit{AALoess} function normalises data sets which share a common set of identifiers (typically probe names if all the experiments are carried out on a single platform) by comparison to a baseline file which typically contains an average of many datasets (for example as produced by \textit{Baseline}).  If the files to be analysed contain different numbers of identifiers, the output will contain only the data for the IDs common to the whole set. The underlying assumption is that the overall expression distribution over all the probes is the same in all samples, and that most probes are unchanged when comparing any two samples. The normalisation rationale is discussed in more detail in Chain et al. (see Bibliography)  . The function also outputs a frequency histogram of the distances between  each sample an the baseline which has proved useful in identifying technical outliers (e.g. if there is a problem in hybridization, for example).  

Examples. This example takes the files in agilp/extdata/raw, LOess normalises them and saves them in agilp/output folder.
<<>>=
inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
baselinedir<-file.path(system.file(package="agilp"),"extdata","testbase.txt", fsep = .Platform$file.sep)
AALoess(input=inputdir, output=outputdir, baseline = baselinedir, LOG="TRUE") 
@
After running this function review the SSE plot and file to identify outliers - note these in template file.

Alternatively the following example does not log transform the data.
<<>>=
AALoess(input=inputdir, output=outputdir, baseline = baselinedir, LOG="FALSE")
@
To remove these files again and empty the output directory use :\newline
<<>>=
unlink(file.path(system.file(package="agilp"),"output","","*.*", 
fsep = .Platform$file.sep), recursive=FALSE)
@
\item \textbf{IDswop. Maps expression data across different bioinformatic identifiers.} \textit{IDswop} replaces one set of identifiers associated with an expression data set (for example platform specific probe IDs) by another set (for example ENSEMBL transcript IDs). This allows expression data sets from different platforms to be combined for analysis . Any appropriate mapping spreadsheet file which contains the source identifiers in one column and the equivalent target IDs in another column can be used. We have typically used files produced by biomaRt, but suitable annotation files can also be made using the \textbf{select} function, in the AnnotationDbi package.  If multiple source IDs(e.g. probe IDs) map to the same target ID the function returns the mean or the maximum value within the set. 

Examples. This example maps expression data from Agilent ProbeIDs (found in column one of input files) to corresponding EnsemblID. Each output file has the name of the original file with the suffix "\_EnsemblID". If multiple probes map to the same ID and vary by more than 20\% they are discarded.
<<>>=
inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
annotation<-file.path(system.file(package="agilp"),"extdata","annotations_sample.txt", fsep = .Platform$file.sep)
IDswop(input=inputdir,output=outputdir,annotation=annotation,source_ID="ProbeID",
target_ID="EnsemblID", ERR=0.2)
@

Alternatively the following keeps all output IDs, even when multiple probes map to a single annotation.
<<>>=
IDswop(input=inputdir,output=outputdir,annotation=annotation,source_ID="ProbeID",
target_ID="EnsemblID", ERR=1)
@

More details of how to use this function are given in the \textit{IDSwop} individual help file. \textit{IDSwop} and 
\textit{Equaliser} (see below) should be used BEFORE \textit{Baseline} and \textit{AALoess}.
To remove these files again and empty the output directory use :\newline
<<>>=
unlink(file.path(system.file(package="agilp"),"output","","*.*", 
fsep = .Platform$file.sep), recursive=FALSE)
@
\item \textbf{Equaliser. Trims a set of gene expression data files to include only the set of identifiers common to all files.} Different platforms will typically generate files with different numbers of distinct identifiers (for example compare the Agilent 44K and Agilent 60K whole genome expression arrays. Different numbers of identifiers will also often result from use of \textit{IDSwop}. \textit{Equaliser} is a utility which takes a set of gene expression data files and trims each file so as to include only the set of IDs which are common to all files in the set. More details  of how to use this function are given in the \textit{IDSwop} individual help file. \textit{Equaliser} and \textit{IDSwop} (see above ) should be used BEFORE \textit{Baseline} and \textit{AALoess}.  

Examples Takes four files in folder agilp/dataset/raw, selects only those entries common to all four, and outputs the shortened files to the folder agilp/output.

<<>>=
inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
Equaliser(input = inputdir, output = outputdir)
@

To remove these files again and empty the output directory use :\newline
<<>>=
unlink(file.path(system.file(package="agilp"),"output","","*.*", 
fsep = .Platform$file.sep), recursive=FALSE)
@
\end{itemize}

\section*{Examples}
All the examples given above and in the individual help files use data files contained within the /extdata folder within the installed agilp folder. The output is sent to the agilp/output folder. To locate the path of the agilp folder on your computer type 
<<>>=
file.path(system.file(package="agilp"))
@


\section*{Bibliography}
\begin{enumerate}
\item Tomlinson GS, Booth H, Petit SJ, Potton E, Towers GJ, Miller RF, Chain BM,
Noursadeghi M. Adherent human alveolar macrophages exhibit a transient
pro-inflammatory profile that confounds responses to innate immune stimulation.
PLoS One. 2012;7(6):e40348. Epub 2012 Jun 29. PubMed PMID: 22768282; PubMed
Central PMCID: PMC3386998.


\item Tomlinson GS, Cashmore TJ, Elkington PT, Yates J, Lehloenya RJ, Tsang J, Brown
M, Miller RF, Dheda K, Katz DR, Chain BM, Noursadeghi M. Transcriptional
profiling of innate and adaptive human immune responses to mycobacteria in the
tuberculin skin test. Eur J Immunol. 2011 Nov;41(11):3253-60. doi:
10.1002/eji.201141841. Epub 2011 Aug 30. PubMed PMID: 21805471; PubMed Central
PMCID: PMC3258543.


\item Le Bert N, Chain BM, Rook G, Noursadeghi M. DC priming by M. vaccae inhibits
Th2 responses in contrast to specific TLR2 priming and is associated with
selective activation of the CREB pathway. PLoS One. 2011 Apr 1;6(4):e18346.
PubMed PMID: 21483768; PubMed Central PMCID: PMC3069967.


\item Chain B, Bowen H, Hammond J, Posch W, Rasaiyaah J, Tsang J, Noursadeghi M.
Error, reproducibility and sensitivity: a pipeline for data processing of Agilent
oligonucleotide expression arrays. BMC Bioinformatics. 2010 Jun 24;11:344. PubMed
PMID: 20576120; PubMed Central PMCID: PMC2909218.


\item Tsang J, Chain BM, Miller RF, Webb BL, Barclay W, Towers GJ, Katz DR,
Noursadeghi M. HIV-1 infection of macrophages is dependent on evasion of innate
immune cellular activation. AIDS. 2009 Nov 13;23(17):2255-63. PubMed PMID:
19741482; PubMed Central PMCID: PMC2873676.


\item Rasaiyaah J, Noursadeghi M, Kellam P, Chain B. Transcriptional and functional 
defects of dendritic cells derived from the MUTZ-3 leukaemia line. Immunology.
2009 Jul;127(3):429-41. PubMed PMID: 19538250; PubMed Central PMCID: PMC2712111.
\end{enumerate}
\end{document}

\name{Baseline}
\alias{Baseline}

%- Also NEED an '\alias' for EACH other topic documented here.

\title{Constructs a file with the mean  of each probe from a set of raw expression array data files} 

\description{Calculates the mean expression data for each probe or identifier  for a set of expression array data sets, for example as produced by AAProcess.  Identifiers (e.g. probe names) must lie in the first column of each file. Identifiers not common to all files in set are discarded. The set of files is either all files in input directory or a set of files defined using a template file. Template is typically an Excel spreadsheet saved as a tab delimited txt fiel, with file names as one column. The files to be used must be specified in a contiguous set of rows of the template file.
}
\usage{
Baseline(NORM="LOG",allfiles="TRUE",r=2,A=2,B=3,input=file.path(system.file(package="agilp"),"input",""),baseout=file.path(system.file(package="agilp"),"output","baseline.txt"),t=file.path(system.file(package="agilp"),"input1","template.txt"))
}

\arguments{
  \item{input}{full path of directory where input data files are put; default is a folder named input within the agilp package directory}
  \item{t}{full name and path of template file; default is the file template.txt in folder agilp/input1}
  \item{baseout}{full name and path of output file with mean expression values; default is the file baseline.txt in folder agilp/output}
  \item{NORM}{if NORM="LOG",  the data are log base 2 transformed before the mean is calculated. The default is NORM="LOG"}
  \item{r}{The column of template which contains the file names}
  \item{A}{The first row of template to be used; note a header row is NOT ignored.}
  \item{B}{The last row of template to be used}
  \item{allfiles}{If allfiles is TRUE, the script uses all files in the input directory, and template is ignored; if allfiles=FALSE,
the scritp uses files defined by template
}
}
\value{
	 \item{baseout}{A tab delimited text file, with each identifier and its mean value,is written to the filename and path defined by baseout}
}

\details{This function is typically used as part of the data processing pipeline to calculate an average against which to normalise all data files using AALoessfunction }

\section{Warning}{The function checks that files listed in template exist in folder, and outputs a list of all file names not found}

\author{Benny Chain; b.chain@ucl.ac.ucl}
\seealso{\code{\link{AAProcess}}
	\code{\link{filenamex}}
	\code{\link{IDswop}}
	\code{\link{Loader}}
	\code{\link{Equaliser}}
	\code{\link{AALoess}}
}
\references{In preparation}
\examples{
#Takes four files of raw data in folder agilp/extdata/raw, calculates the mean expression value for each probe, and saves as agilp/output/testbase.txt.

inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputbase<-file.path(system.file(package="agilp"),"output", "testbase.txt", fsep = .Platform$file.sep)
template<-file.path(system.file(package="agilp"),"extdata","sample_template.txt", fsep = .Platform$file.sep)
Baseline(NORM="LOG",allfiles="TRUE",r=2,A=2,B=3,input=inputdir, baseout=outputbase, t = template)

#Alternatively the following example uses only those data files defined in column 2, rows 2-5 of the template file. In additon, this example does not log transform the data.
Baseline(NORM="FALSE",allfiles="FALSE",r=2,A=2,B=5,input=inputdir, baseout=outputbase, t = template)

\dontrun{
#to remove the output files again and empty the output directory use 
unlink(paste(file.path(system.file(package="agilp"),"output",""),"*.*",sep=""), recursive=FALSE)
}

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{utilities}
\keyword{data}
% __ONLY ONE__ keyword per line

\name{AAProcess}
\alias{AAProcess}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Extracts raw expression data from Agilent expression array scanner files.}

\description{This function takes scanner "txt format" files produced by the Agilent microarray scanner, extracts just the raw median intensity values from the columns marked "gMedianSignal" or "rMedianSignal". Replicate probes  are averaged. The expression data for each colour is written as separate txt tab delimited files with the same name as the original plus prefix rRaw_ or gRaw_. Probe names are in the first column, expression values in the second column. 
}
\usage{
AAProcess(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output/",""),s=9)

}

\arguments{
  \item{input}{full path of directory where input data files are put; default is a folder named input within the agilp package directory}
  \item{output}{full path of directory where output data files are put; default is a folder named output within the agilp package directory}
  \item{s}{number of header lines to skip when reading in scanner files. Default is 9}
}
\value{
	 \item{rawdata files}{ The function writes a set of tab delimited txt files containing the raw data for each channel to directory defined by output. The raw data files are given the same name as the input data files with the prefix Rawg and Rawr for green and red channel respectively. The output files can be readily opened in Excel.  In R each file is a dataframe, which contains probe names in first column, and expression data in second column. Replicate probes are averaged.} 
}

\details{The input directory must have ONLY the data files to be analysed.}
\author{Benny Chain; b.chain@ucl.ac.uk}
\seealso{\code{\link{Loader}}
	\code{\link{filenamex}}
	\code{\link{IDswop}}
	\code{\link{Baseline}}
	\code{\link{Equaliser}}
	\code{\link{AALoess}}
}
\references{In preparation}

\examples{dir()

#This examples extracts expression data from two sample array scanner files which are found in the folder "scanner" within the agilp package extdata folder
#and places them in the folder output.
inputdir<-file.path(system.file(package="agilp"),"extdata","scanner","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
AAProcess(input = inputdir, output = outputdir, s = 9)

\dontrun{
#to remove these files again and empty the output directory use 
unlink(paste(file.path(system.file(package="agilp"),"output\\",""),"*.*",sep=""), recursive=FALSE)

#The number of lines header to be skipped from scanner array files can be changed from the default value of 9 by setting variable s.
AAProcess(input = inputdir, output = outputdir, s = 12)
   }
  }

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{data}% __ONLY ONE__ keyword per line

\name{AALoess}
\alias{AALoess}

%- Also NEED an '\alias' for EACH other topic documented here.
\title{Normalises a set of gene expression data files using LOESS}
\description{This script normalises a set of gene expression data files against a predefined reference data set. The normalisation uses LOESS regression. The major assumption is that the actual data and the reference set have a similar epxression frequency distribution. Typically, the reference set used the is average of a large number of datasets such as the output of Baseline script in this package. The script also calculates the Sum of Squared Errror (SSE) between each data point of the normalised data set and the reference, and plots the results as a histogram of the SSE of all the data sets processed. This function is useful to identify outliers, which are usually due to problems in sample prepration/processing, which are frequently not identified by using the internal scanner quality performance indicators. 
}

\usage{
AALoess(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output",""), baseline=file.path(system.file(package="agilp"),"input1","testbase.txt"),LOG="TRUE")
}


\arguments{
  \item{input}{full path of directory where input data files are put; default is a folder named input within the agilp package directory; the
	  input directory must contain ONLY the set of files to be processed. The input files must
  contain two columns only, the source identifier in the first column, and the expression data in
  the second column; see example files }
  \item{output}{full path of directory where output data files are put; default is a folder named output within the agilp package directory}
  \item{LOG}{if NORM="LOG",  the data are log base 2 transformed before normalisation. The default is NORM="LOG"}
  \item{baseline}{full path of file containing the reference data set for normalisation; the default is agilp/input1/baseline.txt} 
}

\value{\item{normalised datafiles}{One new file is written to the output folder for each input file. The format of the output files is the same as the input, but the data has been normalised. The normalised files are identified by the prefix nr_ or ng_}
         \item{SSE_date.txt file}{A file in the output folder containing a list of all the filenames in the input folder, and the corresponding SSE value}.
}


\author{Benny Chain; b.chain@ucl.ac.uk}
\seealso{\code{\link{AAProcess}}
	\code{\link{filenamex}}
	\code{\link{Loader}}
	\code{\link{Baseline}}
	\code{\link{IDswop}}
	\code{\link{Equaliser}}
}
 
\references{In preparation; for further detail on normalisation see also Chain B, Bowen H, Hammond J, Posch W, Rasaiyaah J, Tsang J, Noursadeghi M.
Error, reproducibility and sensitivity: a pipeline for data processing of Agilent
oligonucleotide expression arrays. BMC Bioinformatics. 2010 Jun 24;11:344.}

\examples{
#Takes four files of raw data (output of AAProcess, in dataset/raw folder) , LOess normalises them and saves them in output folder
inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
baselinedir<-file.path(system.file(package="agilp"),"extdata","testbase.txt", fsep = .Platform$file.sep)
AALoess(input=inputdir, output=outputdir, baseline = baselinedir, LOG="TRUE") 
\dontrun{
#to remove these files again and empty the output directory use 
unlink(paste(file.path(system.file(package="agilp"),"output",""),"*.*",sep=""), recursive=FALSE)
}
	}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}
\keyword{data}% __ONLY ONE__ keyword per line

\name{filenamex}
\alias{filenamex}

%- Also NEED an '\alias' for EACH other topic documented here.

\title{A file name listing utility} 

\description{Generates a text file with the name of all files in a given directory and saves it as a tab delimited txt file. Helpful for filling in template files (see Loader) without making mistakes}

\usage{filenamex(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output",""))
}

\arguments{
  \item{input}{full path of directory where input data files are put; default is a folder named input within the agilp package directory}
  \item{output}{full path of directory where output data files are put; default is a folder named output within the agilp package directory}
}
\value{
	 \item{names.txt}{A tab delimited text file with the names of all the files in the input directory}
}
\details{None}

\author{Benny Chain; b.chain@ucl.ac.ucl}
\seealso{\code{\link{AAProcess}}
	\code{\link{Loader}}
	\code{\link{IDswop}}
	\code{\link{Baseline}}
	\code{\link{Equaliser}}
	\code{\link{AALoess}}
}
\references{In preparation}
\examples{
#This example makes a list of files in the folder agilp/extdata/raw and saves it in a file called names.txt (tab delimited) in the folder agilp/output.
inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
filenamex(input=inputdir,output=outputdir)

\dontrun{
#to remove these files again and empty the output directory use 
unlink(paste(file.path(system.file(package="agilp"),"output",""),"*.*",sep=""), recursive=FALSE)

   }
}

\keyword{file}% __ONLY ONE__ keyword per line

\name{Loader}
\alias{Loader}

%- Also NEED an '\alias' for EACH other topic documented here.

\title{A file choser utility file.}
\description{Uses a template file (typically an Excel spreadsheet with file names as one column) to select a set of files and either combine them into one file or copy them individually to a new directory. The files to be used must be specified in a contiguous set of rows of the template file.
}
\usage{
Loader(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output",""),t=file.path(system.file(package="agilp"),"input1","template.txt"),f="TRUE",r=2,A=2,B=5)
}

\arguments{
  \item{input}{full path of directory where input data files are put; default is a folder named input within the agilp package directory;}
  \item{output}{full path of directory where output data files are put; default is a folder named output within the agilp package directory;}
  \item{t}{full name and path of template file}
  \item{f}{if f="TRUE",  each file is copied individually to output folder; if "f" IS NOT true, all files are merged into one big dataframe , with each original file data as column; this file is called "all_data.txt"  and written to  output folder; it is also returned as an R dataframe object called dataout }
  \item{r}{The column of template which contains the file names}
  \item{A}{The first row of template to be used; note a header row is NOT ignored.}
  \item{B}{The last row of template to be used}
}
\value{
	 \item{rawdata files}{If f is "TRUE" the function simply copies the files defined by template from input to output folder. }
	 \item{dataout}{If f is not = "TRUE" , the individual data files are merged by rows. The rownames are the probe names; each column contains a set of expression data with the column name giving the file name from which the data were derived}
	 \item{all_data}{If f is not = "TRUE" the function also writes a tab delimited txt file corresponding to dataout, called all_data.txt to the output directory. } 
}

\details{This function is a tool for working with selected files output by AAProcess. Typical usage would be to hold all the array file names with relevant experimental detail and annotation in a file called template. The filenames would then be sorted according to some annoation (e.g. tissue type, date, experimenter etc and then this list is used to pull out the relevant raw data files corresponding to those epxeriments from a big collection of such files. A toy example of a template file is provided in data folder}
\section{Warning}{The function checks that files listed in template exist in folder, and outputs a list of all file names not found}
\author{Benny Chain; b.chain@ucl.ac.ucl}
\seealso{\code{\link{AAProcess}}
	\code{\link{filenamex}}
	\code{\link{IDswop}}
	\code{\link{Baseline}}
	\code{\link{Equaliser}}
	\code{\link{AALoess}}
}
\references{In preparation}
\examples{

inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
template<-file.path(system.file(package="agilp"),"extdata","sample_template.txt", fsep = .Platform$file.sep)

#This will copy the files with names given in column 2 , rows 2:3 of the sample_#template file from input to output. 
Loader(input=inputdir,output=outputdir,t=template,f="TRUE",r=2,A=2,B=5)

#Alternatively this will output a single file all_data.txt with the same data in a merged file. The file is also output back to R as object dataout
Loader(input=inputdir,output=outputdir,t=template,f="FALSE",r=2,A=2,B=5)

dim(dataout)

\dontrun{
#to remove the output files again and empty the output directory use 
unlink(paste(file.path(system.file(package="agilp"),"output",""),"*.*",sep=""), recursive=FALSE)
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}
\keyword{data}% __ONLY ONE__ keyword per line

\name{IDswop}
\alias{IDswop}

%- Also NEED an '\alias' for EACH other topic documented here.

\title{Mapping expression data across bioinformatic identifiers
}
\description{This script maps expression data associated with a source identifier (typically a platform
	specific identifier such as ProbeID, as output by AAProcess in the agilp package for example), to another
	identifier of the user's choice. The script uses an annotation file which contains the
	mappings between identifiers. Each column denotes a different identifier, which is
	shown in the column heading. Typical examples include ProbeID, EntrezGeneID,
	EnsemblTranscriptID etc.) Annotation files are provided by microarray manufacturers,or,
	preferably are created using, for example the biomaRt package in Bioconductor. 
}
\usage{
IDswop(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output",""),fun="mean",annotation=file.path(system.file(package="agilp"),"input1","annotation.txt"), source_ID = "ProbeID", target_ID="EnsemblID", ERR=0.2)
}

\arguments{
  \item{input}{full path of directory where input data files are put; default is a folder named input within the agilp package directory; the
	  input directory must contain ONLY the set of files to be processed. The input files must contain two columns only, the source identifier in the first column, and the expression data in
  the second column; see example files in datasets folder}
  \item{output}{full path of directory where output data files are put; default is a folder named input within the agilp package directory}
  \item{fun}{the function to be applied in cases where multiple probes map to the same
	  identifier; currently allowed values are "mean" or "max".}
  \item{annotation}{full path of annotation file; default is a file called annotation.txt within a folder named input1 within the agilp package directory}
  \item{source_ID}{The identifier from which the data is mapped. This must appear exactly as it
	  appears in the heading of the appropriate  column of the annotation file.} 
  \item{target_ID}{The identifier to which the data is mapped. This must appear exactly as it
	  appears in the heading of the appropriate  column of the annotation file}
  \item{ERR}{The cut-off for coefficient of variation allowed when multiple probes map to a
	  single identifier. ERR must lie between 0 and 1. If ERR=0, any difference
	  between such probes will result in the identifier being omitted from the final list.  If
	  ERR=1,  all identifiers are retained. The default is 0.2, allowing a
	  maximum coefficient of  variation between multiple probes mapping to a single
	  identifier of 20\%. }
	  }
\value{
	 \item{remapped datafiles}{One new file is produced for each input file. Each file contains two columns; the first contains the new set of identifiers; the second contains the corresponding expression value. The file name contains the new identifier as a suffix. }
	 
}

\details{This function is designed for merging expression data sets from different
	platforms using common bioinformatic identifiers such as gene names, transcript names etc.
	The major problem lies in how to deal with the "many to many" mapping which
	characterise the relationships between most standard identifiers. IDswop deals with the problem as follows. If	multiple source identifiers (typically platform specific probe IDs) map to a single target (for example Ensembl_Transcript_ID ) , the different probes are either
	averaged (fun="mean") or the maximum is selected (fun="max"). However, in cases where the discrepancy between such sets of probes is too large, the identifier is discarded,
	since it is considered as being unreliable. The degree of error allowed can be set by the user, as described under a descrition of the ERR variable given above. In cases where a
	single source identifier maps to multple targets (e.g. one probe to several
	transcript IDs) each transcript is retained as a separate entry in the final list, with an identical expression value. }

\author{Benny Chain; b.chain@ucl.ac.uk}
\seealso{\code{\link{AAProcess}}
	\code{\link{filenamex}}
	\code{\link{Loader}}
	\code{\link{Baseline}}
	\code{\link{Equaliser}}
	\code{\link{AALoess}}
}
\references{In preparation}
\examples{

#This examples maps expression data from Agilent ProbeIDs (found in column one of input files) to corresponding EnsemblID. Each output file has the name of the original file with the suffix "_EnsemblID". If multiple probes map to teh same ID and vary by more than 20% they are discarded.


inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)
outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)
annotation<-file.path(system.file(package="agilp"),"extdata","annotations_sample.txt", fsep = .Platform$file.sep)
IDswop(input=inputdir,output=outputdir,annotation=annotation,source_ID="ProbeID",target_ID="EnsemblID", ERR=0.2)

#Alternatively the following keeps all output IDs, even when multiple probes map to a single

IDswop(input=inputdir,output=outputdir,annotation=annotation,source_ID="ProbeID",target_ID="EnsemblID", ERR=1)

\dontrun{
#to remove the output files again and empty the output directory use 
unlink(paste(file.path(system.file(package="agilp"),"output",""),"*.*",sep=""), recursive=FALSE)
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}
\keyword{data}% __ONLY ONE__ keyword per line

\name{Equaliser}
\alias{Equaliser}

%- Also NEED an '\alias' for EACH other topic documented here.

\title{Trims a set of gene expression data files to include only the set of identifiers common to all files
}
\description{This script processes a set of gene expression data files which  have different number of entries (i.e. different numbers of identifiers).  Further processing of data files usually requires equal number of identifiers in each file (e.g. AALoess or Baseline in this package). The Equaliser script cycles through a series of such datafiles, determines the set of  identifiers common to all files in the directory, and outputs a set of files which retain only those identifiers common to the whole set. 
}
\usage{
Equaliser(input=file.path(system.file(package="agilp"),"input",""),output=file.path(system.file(package="agilp"),"output",""))
}

\arguments{
  \item{input}{full path of directory where input data files are put; default is a folder named input within the agilp package directory; the input directory must contain ONLY the set of files to be processed. The input files must contain two columns only, the source identifier in the first column, and the expression data in the second column; see example files}
  \item{output}{full path of directory where output data files are put; default is a folder named output within the agilp package directory}
}


\value{
  \item{equalised datafiles}{One new file is produced for each input file. The file name has an additonal s_ as a suffix. }
	 }

\details{This utility is particularly useful to process the output of IDswop in the agilp package. IDswop excludes some identifiers on the basis of a cutoff which is data dependent, and may therefore generate files with different numbers of identifiers between samples. }

\author{Benny Chain; b.chain@ucl.ac.uk}
\seealso{\code{\link{AAProcess}}
	\code{\link{filenamex}}
	\code{\link{Loader}}
	\code{\link{Baseline}}
	\code{\link{IDswop}}
	\code{\link{AALoess}}
}
\references{In preparation}
\examples{
##Takes four files of raw data (output of AAProcess, in folder agilp/dataset/raw) selects all entries common to all four, and outputs the shortened files to the folder agilp/output.

inputdir<-file.path(system.file(package="agilp"),"extdata","raw/","", fsep = .Platform$file.sep)

outputdir<-file.path(system.file(package="agilp"),"output/", "", fsep = .Platform$file.sep)

Equaliser(input = inputdir, output = outputdir)

\dontrun{
#to remove these files again and empty the output directory use 
unlink(paste(file.path(system.file(package="agilp"),"output",""),"*.*",sep=""), recursive=FALSE)

   }
  }


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{utilities}
\keyword{data}% __ONLY ONE__ keyword per line
